from __future__ import annotations
from threading import Lock, Thread
from typing import Optional
# -*- coding: utf-8 -*-
"""
Created on Mon Feb  7 19:50:47 2022

@author: krein_000
"""
from intern.gng_klassen import Rechteck, Kreis
import time


class SingletonMeta(type):
    """ 
    Hilfsklasse zur Realisierung des Singleton-Musters, damit zu jeder Zeit nur ein einziges Objekt der Klasse Zeichenfenster existiert. 
    """
    _instanz: Optional[Singleton] = None
    _lock: Lock = Lock()


    def __call__(cls, *args, **kwargs):
        """ 
        Methode sorgt dafür, dass nur ein Objekt der Klasse ausgegeben wird.
        """
        with cls._lock:
            if not cls._instanz:
                cls._instanz = super().__call__(*args, **kwargs)
        return cls._instanz



class MethodenboxIntern(Thread, metaclass=SingletonMeta):


    def __init__(self):
        """
        Erzeugt eine neue Methodenbox für das Arbeiten mit Bildern und Textfeldern
        """
        hilf = Rechteck()
        hilf.PositionSetzen(100, 50)
        hilf.GroesseSetzen(50, 150)
        hilf.FarbeSetzen("schwarz")
        hilf = Rechteck()
        hilf.PositionSetzen(103, 53)
        hilf.GroesseSetzen(44, 144)
        hilf.FarbeSetzen("weiss")
        hilf = Rechteck()
        hilf.PositionSetzen(100, 98)
        hilf.GroesseSetzen(50, 4)
        hilf.FarbeSetzen("schwarz")
        hilf = Rechteck()
        hilf.PositionSetzen(100, 148)
        hilf.GroesseSetzen(50, 4)
        hilf.FarbeSetzen("schwarz")
        
        self.lampeOben = Kreis()
        self.lampeOben.PositionSetzen(125, 75)
        self.lampeOben.RadiusSetzen(20)
        self.lampeOben.FarbeSetzen("rot")
        self.lampeMitte = Kreis()
        self.lampeMitte.PositionSetzen(125, 125)
        self.lampeMitte.RadiusSetzen(20)
        self.lampeMitte.FarbeSetzen("schwarz")
        self.lampeUnten = Kreis()
        self.lampeUnten.PositionSetzen(125, 175)
        self.lampeUnten.RadiusSetzen(20)
        self.lampeUnten.FarbeSetzen("schwarz")

        self.ampelphase = "rot"




    def RotGelbSetzen(self):
        self.lampeOben.FarbeSetzen("rot")
        self.lampeMitte.FarbeSetzen("gelb")
        self.lampeUnten.FarbeSetzen("schwarz")
        self.ampelphase = "rotgelb"

    def GruenSetzen(self):
        self.lampeOben.FarbeSetzen("schwarz")
        self.lampeMitte.FarbeSetzen("schwarz")
        self.lampeUnten.FarbeSetzen("grün")
        self.ampelphase = "grün"

    def GelbSetzen(self):
        self.lampeOben.FarbeSetzen("schwarz")
        self.lampeMitte.FarbeSetzen("gelb")
        self.lampeUnten.FarbeSetzen("schwarz")
        self.ampelphase = "gelb"   
    
    def RotSetzen(self):
        self.lampeOben.FarbeSetzen("rot")
        self.lampeMitte.FarbeSetzen("schwarz")
        self.lampeUnten.FarbeSetzen("schwarz")
        self.ampelphase = "rot"
        
    def AmpelphaseGeben(self):
        return self.ampelphase